<?php

########################################################################################
# Dateiname:		getOBKPIMonth.php
#
# Beschreibung:		Liefert KPI Kennzahlen der letzten 4 Wochen im JSON Format
#
# Author:		Marc Mader (marc.mader@aem-et.de)
# Datum:		24.11.2017
# Copyright:		AEM August Elektrotechnik GmbH, Seerasen 4-6, 36284 Hohenroda
#
#
#
#
########################################################################################

error_reporting(E_ALL);
ini_set('display_errors',1);


function dbconnect()
{
    $link = mysql_connect("localhost", "buradmin", ".buradmin") or die("Keine Verbindung zur Datenbank moeglich!");
    mysql_select_db("BUR_PDA") or die("Die Datenbank BUR_PDA existiert nicht!");
    return $link;
}

function tableFromRS($rs)
{
    echo "<table border=1>";
    for ($i = 0; $i < mysql_num_fields($rs); $i++) {
        $field_info = mysql_fetch_field($rs, $i);
        echo "<th>{$field_info->name}</th>";
    }
    while ($red = mysql_fetch_row($rs)) {

        echo "<tr>";
        foreach ($red as $v) {
            echo "<td>$v</td>";
        }
        echo "</tr>";
    }

    echo "</table>";
}

function getAIKPI($ObLineID, $start, $end)
{
    $rows = array();
    $dblink = dbconnect();


 $query  = '
                SELECT
                      DATE_FORMAT(DATE_ADD(starttime, INTERVAL(2-DAYOFWEEK(starttime)) DAY),"%Y-%m-%d 06:00:00") as start,
                      DATE_FORMAT(DATE_ADD(starttime, INTERVAL(9-DAYOFWEEK(starttime)) DAY),"%Y-%m-%d 06:00:00") as end,
                      CONCAT(YEAR(starttime)," KW ",  IF(WEEK(DATE_SUB(starttime, INTERVAL 6 DAY_HOUR),1)<10, CONCAT("0",WEEK(DATE_SUB(starttime, INTERVAL 6 DAY_HOUR),1)),WEEK(DATE_SUB(starttime, INTERVAL 6 DAY_HOUR),1)) ) as `xAxisDesc`,
                      (
                    sum(product_counter) -
                    (sum(reject_counter) +
                    sum(reject_counter_additional)	)
                      )
                      /
                      ((SELECT sum(duration / 3600000) FROM `BUR_PDA`.`OrangeBoxTimeline` WHERE ob_line_id="'. $ObLineID .'" and DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) > start  and starttime <  end    and state!="ASSET_IDLE") *
                      ((SELECT sum(duration * nominalproductionrate / 3600000) / sum(duration / 3600000) FROM BUR_PDA.`OrangeBoxTimeline`  WHERE state!="ASSET_IDLE" and ob_line_id="'. $ObLineID .'" and DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) >  start  and starttime <   end   ))
                      ) * 100
                      as value
                  FROM
                      BUR_PDA.`OrangeBoxTimeline`
                  WHERE
                      ob_line_id = "'. $ObLineID .'" and
                      DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $start . '" and starttime < "' . $end . '"
                  GROUP BY
                      `xAxisDesc`
                ';


    $result = mysql_query($query);

    while($row = mysql_fetch_assoc($result))
    {
        array_push($rows, $row);
    }
    mysql_close($dblink);
    if (count($rows) > 0)
    {
        return $rows;
    }
    else
    {
        return null;
    }
}

function getAIKPIDyn($ObLineID, $starttime, $endtime)
{
    $dblink = dbconnect();
    $query  = '
                    SELECT
                      ((SELECT sum(product_counter) - sum(reject_counter) - sum(reject_counter_additional)) /
                          (
                              (SELECT sum(duration / 3600000) FROM OrangeBoxTimeline WHERE ob_line_id = "' . $ObLineID . '"
                                  and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '" and starttime < "' . $endtime . '" and state != "ASSET_IDLE") * (
                                  (SELECT sum(duration * nominalproductionrate / 3600000) / sum(duration / 3600000) FROM OrangeBoxTimeline WHERE ob_line_id = "' . $ObLineID . '"
                                      and state != "ASSET_IDLE"
                                      and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '" and starttime < "' . $endtime . '")
                              )
                          )) * 100
                  as assetintensity
                  FROM
                  OrangeBoxTimeline
                  WHERE
                  ob_line_id = "' . $ObLineID . '"
                  and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '" and starttime < "' . $endtime . '"';
    $result = mysql_query($query);
    return mysql_fetch_array($result);
    mysql_close($dblink);
}

function getUnplStopsKPI($ObLineID, $start, $end)
{
    $rows = array();
    $dblink = dbconnect();
    $query  = 'SELECT
                     DATE_FORMAT(DATE_ADD(starttime, INTERVAL(2-DAYOFWEEK(starttime)) DAY),"%Y-%m-%d 06:00:00") as start,
                      DATE_FORMAT(DATE_ADD(starttime, INTERVAL(9-DAYOFWEEK(starttime)) DAY),"%Y-%m-%d 06:00:00") as end,
                     CONCAT(YEAR(starttime)," KW ",  IF(WEEK(DATE_SUB(starttime, INTERVAL 6 DAY_HOUR),1)<10, CONCAT("0",WEEK(DATE_SUB(starttime, INTERVAL 6 DAY_HOUR),1)),WEEK(DATE_SUB(starttime, INTERVAL 6 DAY_HOUR),1)) ) as `xAxisDesc`,
                    (sum(duration)/
                    (SELECT sum(duration) FROM `BUR_PDA`.`OrangeBoxTimeline` WHERE ob_line_id="'. $ObLineID .'" and state!="ASSET_IDLE" and state!="ASSET_SCHEDDT" and DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) >  start and starttime <  end )  * 100) as value

                FROM
                    BUR_PDA.`OrangeBoxTimeline`
                WHERE
                    ob_line_id= "'. $ObLineID .'" and
                    state="ASSET_UNSCHEDDT" and
                  DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) >  "' . $start . '"  and starttime <=  "' . $end . '"
                group by xAxisDesc
  ';
    //echo $query;
    $result = mysql_query($query);

    while($row = mysql_fetch_assoc($result))
    {
        array_push($rows, $row);
    }
    mysql_close($dblink);
    if (count($rows) > 0)
    {
        return $rows;
    }
    else
    {
        return null;
    }
}

function getPlStopsKPI($ObLineID, $start, $end)
{
    $rows = array();
    $dblink = dbconnect();
    $query  = 'SELECT
                      DATE_FORMAT(DATE_ADD(starttime, INTERVAL(2-DAYOFWEEK(starttime)) DAY),"%Y-%m-%d 06:00:00") as start,
                      DATE_FORMAT(DATE_ADD(starttime, INTERVAL(9-DAYOFWEEK(starttime)) DAY),"%Y-%m-%d 06:00:00") as end,
                      CONCAT(YEAR(starttime)," KW ",  IF(WEEK(DATE_SUB(starttime, INTERVAL 6 DAY_HOUR),1)<10, CONCAT("0",WEEK(DATE_SUB(starttime, INTERVAL 6 DAY_HOUR),1)),WEEK(DATE_SUB(starttime, INTERVAL 6 DAY_HOUR),1)) ) as `xAxisDesc`,
                    (sum(duration)/
                    (SELECT sum(duration) FROM `BUR_PDA`.`OrangeBoxTimeline` WHERE ob_line_id="'. $ObLineID .'" and state!="ASSET_IDLE" and DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) >  start and starttime <  end )  * 100) as value

                FROM
                    BUR_PDA.`OrangeBoxTimeline`
                WHERE
                    ob_line_id= "'. $ObLineID .'" and
                    state="ASSET_SCHEDDT" and
                   DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $start . '" and starttime < "' . $end . '"
                group by xAxisDesc
  ';
    //echo $query;
    $result = mysql_query($query);

    while($row = mysql_fetch_assoc($result))
    {
        array_push($rows, $row);
    }
    mysql_close($dblink);
    if (count($rows) > 0)
    {
        return $rows;
    }
    else
    {
        return null;
    }
}

function getPvVal($pv)
{

  $url    = 'https://localhost/iosys/MasterOrangeBox/RUNTIME01/json/get?id=' . $pv;
  $contents = file_get_contents($url);

   if ($contents !== false) {
     $pvraw = json_decode($contents, true);
     // echo var_dump($pvraw);
     return $pvraw[1][0]['val'];
    }
   else{
    return null;
   }
}

function firstDayofFirstWeekinCurrentMonth($date = NULL) {
    $date = is_null ($date) ? new DateTime('first day of this month') : $date->modify('first day of this month');
    $date->modify(('Sunday' == $date->format('l')) ? 'Monday last week' : 'Monday this week');
    return $date;
}

$json = array();

// Check for valid OB_Line_ID, if not return HTTP Bad Request Error (400)
if (isset($_REQUEST['line_id']) and strcmp($_REQUEST['line_id'],"") != 0) {
    $ObLineID = $_REQUEST['line_id'];
} else {
    header('X-PHP-Response-Code: 400', true, 400);
    echo "Error (400) - Bad Request.";
    exit;
}


# Start und Ende für Betrachtungszeitraum festlegen
# start = letzter Montag - 3 Wochen
# ende  = Jetzt
$startdatetime = date("Y-m-d 06:i:s", strtotime("monday this week - 3 week"));
$enddatetime = date("Y-m-d H:i:s");

#$startdatetime = date("Y-m-d 06:00:00", strtotime('first Monday of this Month'));
#$enddatetime = date("Y-m-d H:i:s");




// Connect database
$dblink = dbconnect();

// set timerange


$json["general"]["line_id"] = $ObLineID;
$json["general"]["query_start"] = $startdatetime;
$json["general"]["query_end"] = $enddatetime;

$tmp = getAIKPI($ObLineID, $startdatetime, $enddatetime);
$json['KPI_AssetIntensity']= $tmp;

$tmp = getPlStopsKPI($ObLineID, $startdatetime, $enddatetime);
$json['KPI_PlannedStoppages']= $tmp;

$tmp = getUnplStopsKPI($ObLineID, $startdatetime, $enddatetime);
$json['KPI_UnplannedStoppages']= $tmp;

$tmp = getAIKPIDyn($ObLineID, date("Y-m-d 06:00:00", strtotime('first day of this Month')), $enddatetime );
$json["KPIAIoverall"]["start"] = date("Y-m-d 06:00:00", strtotime('first day of this Month'));
$json["KPIAIoverall"]["end"] = $enddatetime;
$json['KPIAIoverall']['value'] = $tmp['assetintensity'];

echo json_encode($json);
?>
